com.tibco.n2.service.adapter.binding

## Interface OrganisationalEntityConfigService

- All Known Implementing Classes:
    OrganisationalEntityConfigService

      public interface OrganisationalEntityConfigService

  OrganisationalEntityConfigService, provide methods for getting, setting and deleting attributes for a resource.

  The following attributes are available:-

  MaxOpenWorkItemCount - This attribute controls the maximum number of work items that a resource can have open at any one time. If this is not set or a negative value then the number of items allowed open is unlimited.

  WorkItemFilterCriteriaAPI (read only) - This is the work item filter that is used for getting lists of work items through the getWorkListItems() API. If no filter criteria is specified through the getWorkListItems() API then this attribute value, if set, is used. If this isn't set then the default filter is used. This is a read-only attribute and a ReadOnlyAttributeFaultException is thrown if a delete or set is attempted through the OrganisationalEntityConfigService APIs.

  WorkItemFilterCriteriaPARSED (read only) - This is the parsed version of the WorkFilterCriteriaAPI filter. The value of this is a SQL WHERE clause that is used in the actual SELECT used by the getWorkListItems() API. This is a read-only attribute and a ReadOnlyAttributeFaultException is thrown if a delete or set is attempted through the OrganisationalEntityConfigService APIs.

  WorkItemOrderCriteriaAPI (read only) - This is the work item order criteria that is used when getting lists of work items through the getWorkListItems() API. It has been pre-parsed and is in SQL ORDER BY format. This is a read-only attribute and a ReadOnlyAttributeFaultException is thrown if a delete or set is attempted through the OrganisationalEntityConfigService APIs.

  WorkItemAutoOpen - This attribute controls whether to auto-open another work item when a processing the completion of a work item. This takes effect if chaining and piling are both not enabled. This can take value of "1", "0", "true" or "false" to indicate whether to use auto-open. When an item is returned from completion due to being auto-opened or piled, the item is allocated to the resource performing the operation. It is therefore up to the caller to open or unallocated the work item.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `deleteOrgEntityConfigAttributes(java.lang.String[] attributeNames, java.lang.String resourceId)` Deletes one or more attributes for a given resource.
    `com.tibco.n2.brm.api.OrgEntityConfigAttribute[]` | `getOrgEntityConfigAttributes(java.lang.String resourceId)` Returns the attributes that are currently set for a given resource.
    `com.tibco.n2.brm.api.OrgEntityConfigAttributesAvailable[]` | `getOrgEntityConfigAttributesAvailable(int startPos, int numberOfItems)` Returns all the available attributes that can be used.
    `boolean` | `setOrgEntityConfigAttributes(com.tibco.n2.brm.api.OrgEntityConfigAttributeSet[] attributes, java.lang.String resourceId)` Sets one or more attributes for a given resource.

- - ### Method Detail

    - #### deleteOrgEntityConfigAttributes

          boolean deleteOrgEntityConfigAttributes(java.lang.String[] attributeNames,
                                                  java.lang.String resourceId)
                                           throws com.tibco.n2.brm.services.InternalServiceFault,
                                                  com.tibco.n2.brm.services.InvalidEntityFault,
                                                  com.tibco.n2.brm.services.ReadOnlyAttributeFault

      Deletes one or more attributes for a given resource.
      Parameters:
        `attributeNames` - the list of attribute names to delete
        `resourceId` - the resource id
      Returns:
        returns `true` if successful, otherwise `false`
      Throws:
        `java.lang.RuntimeException`
        `com.tibco.n2.brm.services.InternalServiceFault`
        `com.tibco.n2.brm.services.InvalidEntityFault`
        `com.tibco.n2.brm.services.ReadOnlyAttributeFault`

    - #### getOrgEntityConfigAttributes

          com.tibco.n2.brm.api.OrgEntityConfigAttribute[] getOrgEntityConfigAttributes(java.lang.String resourceId)
                                                                                throws com.tibco.n2.brm.services.InternalServiceFault,
                                                                                       com.tibco.n2.brm.services.InvalidEntityFault

      Returns the attributes that are currently set for a given resource. It returns the attribute name, value and whether it is read only or not.
      Parameters:
        `resourceId` - the resource id
      Returns:
        returns a list of objects containing the attribute information
      Throws:
        `java.lang.RuntimeException`
        `com.tibco.n2.brm.services.InternalServiceFault`
        `com.tibco.n2.brm.services.InvalidEntityFault`

    - #### getOrgEntityConfigAttributesAvailable

          com.tibco.n2.brm.api.OrgEntityConfigAttributesAvailable[] getOrgEntityConfigAttributesAvailable(int startPos,
                                                                                                          int numberOfItems)
                                                                                                   throws com.tibco.n2.brm.services.InternalServiceFault

      Returns all the available attributes that can be used. This returns a subset of the attributes returned by calling `getOrgEntityConfigAttributes`, including the name, description and whether it is read only. The only attribute from the list above that is not returned, it is regarded as private, is WorkItemFilterCriteriaPARSED.
      Parameters:
        `startPos` - the starting position
        `numberOfItems` - the number of items to return
      Returns:
        returned a list of objects containing the attribute information
      Throws:
        `java.lang.RuntimeException`
        `com.tibco.n2.brm.services.InternalServiceFault`

    - #### setOrgEntityConfigAttributes

          boolean setOrgEntityConfigAttributes(com.tibco.n2.brm.api.OrgEntityConfigAttributeSet[] attributes,
                                               java.lang.String resourceId)
                                        throws com.tibco.n2.brm.services.InternalServiceFault,
                                               com.tibco.n2.brm.services.ReadOnlyAttributeFault,
                                               com.tibco.n2.brm.services.InvalidEntityFault

      Sets one or more attributes for a given resource. It will either create a new attribute or update an existing one.
      Parameters:
        `attributes` - the list of attribute objects
        `resourceId` - the resource id
      Returns:
        returns `true` if successful, otherwise `false`
      Throws:
        `java.lang.RuntimeException`
        `com.tibco.n2.brm.services.InternalServiceFault`
        `com.tibco.n2.brm.services.ReadOnlyAttributeFault`
        `com.tibco.n2.brm.services.InvalidEntityFault`

Copyright © 2018 TIBCO Software Inc. All Rights Reserved.